/* dasres.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "dasres.h"

void *dasresStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void dasresEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void dasresDasresSave(struct dasresDasres *obj, int indent, FILE *f)
/* Save dasresDasres to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASRES>");
fprintf(f, "\n");
dasresResolveSave(obj->dasresResolve, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASRES>\n");
}

struct dasresDasres *dasresDasresLoad(char *fileName)
/* Load dasresDasres from file. */
{
struct dasresDasres *obj;
xapParseAny(fileName, "DASRES", dasresStartHandler, dasresEndHandler, NULL, &obj);
return obj;
}

void dasresResolveSave(struct dasresResolve *obj, int indent, FILE *f)
/* Save dasresResolve to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<RESOLVE");
fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, ">");
fprintf(f, "\n");
dasresSegmentSave(obj->dasresSegment, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</RESOLVE>\n");
}

struct dasresResolve *dasresResolveLoad(char *fileName)
/* Load dasresResolve from file. */
{
struct dasresResolve *obj;
xapParseAny(fileName, "RESOLVE", dasresStartHandler, dasresEndHandler, NULL, &obj);
return obj;
}

void dasresSegmentSave(struct dasresSegment *obj, int indent, FILE *f)
/* Save dasresSegment to file. */
{
struct dasresRelcoord *dasresRelcoord;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SEGMENT");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, " start=\"%s\"", obj->start);
fprintf(f, " stop=\"%s\"", obj->stop);
fprintf(f, ">");
fprintf(f, "\n");
for (dasresRelcoord = obj->dasresRelcoord; dasresRelcoord != NULL; dasresRelcoord = dasresRelcoord->next)
   dasresRelcoordSave(dasresRelcoord, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</SEGMENT>\n");
}

struct dasresSegment *dasresSegmentLoad(char *fileName)
/* Load dasresSegment from file. */
{
struct dasresSegment *obj;
xapParseAny(fileName, "SEGMENT", dasresStartHandler, dasresEndHandler, NULL, &obj);
return obj;
}

void dasresRelcoordSave(struct dasresRelcoord *obj, int indent, FILE *f)
/* Save dasresRelcoord to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<RELCOORD");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, " start=\"%s\"", obj->start);
fprintf(f, " stop=\"%s\"", obj->stop);
fprintf(f, ">");
fprintf(f, "</RELCOORD>\n");
}

struct dasresRelcoord *dasresRelcoordLoad(char *fileName)
/* Load dasresRelcoord from file. */
{
struct dasresRelcoord *obj;
xapParseAny(fileName, "RELCOORD", dasresStartHandler, dasresEndHandler, NULL, &obj);
return obj;
}

void *dasresStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASRES"))
    {
    struct dasresDasres *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "RESOLVE"))
    {
    struct dasresResolve *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "version"))
            obj->version = cloneString(val);
        }
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASRES"))
            {
            struct dasresDasres *parent = st->object;
            slAddHead(&parent->dasresResolve, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "SEGMENT"))
    {
    struct dasresSegment *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "start"))
            obj->start = cloneString(val);
        else if (sameString(name, "stop"))
            obj->stop = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (obj->start == NULL)
        xapError(xp, "missing start");
    if (obj->stop == NULL)
        xapError(xp, "missing stop");
    if (depth > 1)
        {
        if  (sameString(st->elName, "RESOLVE"))
            {
            struct dasresResolve *parent = st->object;
            slAddHead(&parent->dasresSegment, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "RELCOORD"))
    {
    struct dasresRelcoord *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "start"))
            obj->start = cloneString(val);
        else if (sameString(name, "stop"))
            obj->stop = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (obj->start == NULL)
        xapError(xp, "missing start");
    if (obj->stop == NULL)
        xapError(xp, "missing stop");
    if (depth > 1)
        {
        if  (sameString(st->elName, "SEGMENT"))
            {
            struct dasresSegment *parent = st->object;
            slAddHead(&parent->dasresRelcoord, obj);
            }
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void dasresEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASRES"))
    {
    struct dasresDasres *obj = stack->object;
    if (obj->dasresResolve == NULL)
        xapError(xp, "Missing RESOLVE");
    if (obj->dasresResolve->next != NULL)
        xapError(xp, "Multiple RESOLVE");
    }
else if (sameString(name, "RESOLVE"))
    {
    struct dasresResolve *obj = stack->object;
    if (obj->dasresSegment == NULL)
        xapError(xp, "Missing SEGMENT");
    if (obj->dasresSegment->next != NULL)
        xapError(xp, "Multiple SEGMENT");
    }
else if (sameString(name, "SEGMENT"))
    {
    struct dasresSegment *obj = stack->object;
    if (obj->dasresRelcoord == NULL)
        xapError(xp, "Missing RELCOORD");
    slReverse(&obj->dasresRelcoord);
    }
}

