/* dastypes.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "dastypes.h"

void *dastypesStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void dastypesEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void dastypesDastypesSave(struct dastypesDastypes *obj, int indent, FILE *f)
/* Save dastypesDastypes to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASTYPES>");
fprintf(f, "\n");
dastypesGffSave(obj->dastypesGff, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASTYPES>\n");
}

struct dastypesDastypes *dastypesDastypesLoad(char *fileName)
/* Load dastypesDastypes from file. */
{
struct dastypesDastypes *obj;
xapParseAny(fileName, "DASTYPES", dastypesStartHandler, dastypesEndHandler, NULL, &obj);
return obj;
}

void dastypesGffSave(struct dastypesGff *obj, int indent, FILE *f)
/* Save dastypesGff to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<GFF");
fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, " href=\"%s\"", obj->href);
fprintf(f, ">");
fprintf(f, "\n");
dastypesSegmentSave(obj->dastypesSegment, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</GFF>\n");
}

struct dastypesGff *dastypesGffLoad(char *fileName)
/* Load dastypesGff from file. */
{
struct dastypesGff *obj;
xapParseAny(fileName, "GFF", dastypesStartHandler, dastypesEndHandler, NULL, &obj);
return obj;
}

void dastypesSegmentSave(struct dastypesSegment *obj, int indent, FILE *f)
/* Save dastypesSegment to file. */
{
struct dastypesType *dastypesType;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SEGMENT");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, " start=\"%s\"", obj->start);
fprintf(f, " stop=\"%s\"", obj->stop);
fprintf(f, " version=\"%s\"", obj->version);
if (obj->label != NULL)
    fprintf(f, " label=\"%s\"", obj->label);
fprintf(f, ">");
fprintf(f, "\n");
for (dastypesType = obj->dastypesType; dastypesType != NULL; dastypesType = dastypesType->next)
   dastypesTypeSave(dastypesType, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</SEGMENT>\n");
}

struct dastypesSegment *dastypesSegmentLoad(char *fileName)
/* Load dastypesSegment from file. */
{
struct dastypesSegment *obj;
xapParseAny(fileName, "SEGMENT", dastypesStartHandler, dastypesEndHandler, NULL, &obj);
return obj;
}

void dastypesTypeSave(struct dastypesType *obj, int indent, FILE *f)
/* Save dastypesType to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TYPE");
fprintf(f, " id=\"%s\"", obj->id);
if (obj->method != NULL)
    fprintf(f, " method=\"%s\"", obj->method);
if (obj->category != NULL)
    fprintf(f, " category=\"%s\"", obj->category);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</TYPE>\n");
}

struct dastypesType *dastypesTypeLoad(char *fileName)
/* Load dastypesType from file. */
{
struct dastypesType *obj;
xapParseAny(fileName, "TYPE", dastypesStartHandler, dastypesEndHandler, NULL, &obj);
return obj;
}

void *dastypesStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASTYPES"))
    {
    struct dastypesDastypes *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "GFF"))
    {
    struct dastypesGff *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "version"))
            obj->version = cloneString(val);
        else if (sameString(name, "href"))
            obj->href = cloneString(val);
        }
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (obj->href == NULL)
        xapError(xp, "missing href");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASTYPES"))
            {
            struct dastypesDastypes *parent = st->object;
            slAddHead(&parent->dastypesGff, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "SEGMENT"))
    {
    struct dastypesSegment *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "start"))
            obj->start = cloneString(val);
        else if (sameString(name, "stop"))
            obj->stop = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        else if (sameString(name, "label"))
            obj->label = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (obj->start == NULL)
        xapError(xp, "missing start");
    if (obj->stop == NULL)
        xapError(xp, "missing stop");
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (depth > 1)
        {
        if  (sameString(st->elName, "GFF"))
            {
            struct dastypesGff *parent = st->object;
            slAddHead(&parent->dastypesSegment, obj);
            }
        }
    return obj;
    }
else if (sameString(name, "TYPE"))
    {
    struct dastypesType *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "method"))
            obj->method = cloneString(val);
        else if (sameString(name, "category"))
            obj->category = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "SEGMENT"))
            {
            struct dastypesSegment *parent = st->object;
            slAddHead(&parent->dastypesType, obj);
            }
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void dastypesEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASTYPES"))
    {
    struct dastypesDastypes *obj = stack->object;
    if (obj->dastypesGff == NULL)
        xapError(xp, "Missing GFF");
    if (obj->dastypesGff->next != NULL)
        xapError(xp, "Multiple GFF");
    }
else if (sameString(name, "GFF"))
    {
    struct dastypesGff *obj = stack->object;
    if (obj->dastypesSegment == NULL)
        xapError(xp, "Missing SEGMENT");
    if (obj->dastypesSegment->next != NULL)
        xapError(xp, "Multiple SEGMENT");
    }
else if (sameString(name, "SEGMENT"))
    {
    struct dastypesSegment *obj = stack->object;
    if (obj->dastypesType == NULL)
        xapError(xp, "Missing TYPE");
    slReverse(&obj->dastypesType);
    }
else if (sameString(name, "TYPE"))
    {
    struct dastypesType *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

