/* dg.c autoXml generated file */

#include "common.h"
#include "xap.h"
#include "dg.h"

void *dgStartHandler(struct xap *xp, char *name, char **atts);
/* Called by expat with start tag.  Does most of the parsing work. */

void dgEndHandler(struct xap *xp, char *name);
/* Called by expat with end tag.  Checks all required children are loaded. */


void dgDasgffSave(struct dgDasgff *obj, int indent, FILE *f)
/* Save dgDasgff to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<DASGFF>");
fprintf(f, "\n");
dgGffSave(obj->dgGff, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</DASGFF>\n");
}

struct dgDasgff *dgDasgffLoad(char *fileName)
/* Load dgDasgff from file. */
{
struct dgDasgff *obj;
xapParseAny(fileName, "DASGFF", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgGffSave(struct dgGff *obj, int indent, FILE *f)
/* Save dgGff to file. */
{
struct dgSegment *dgSegment;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<GFF");
fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, " href=\"%s\"", obj->href);
fprintf(f, ">");
fprintf(f, "\n");
for (dgSegment = obj->dgSegment; dgSegment != NULL; dgSegment = dgSegment->next)
   dgSegmentSave(dgSegment, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</GFF>\n");
}

struct dgGff *dgGffLoad(char *fileName)
/* Load dgGff from file. */
{
struct dgGff *obj;
xapParseAny(fileName, "GFF", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgSegmentSave(struct dgSegment *obj, int indent, FILE *f)
/* Save dgSegment to file. */
{
struct dgFeature *dgFeature;
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SEGMENT");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, " start=\"%d\"", obj->start);
fprintf(f, " stop=\"%d\"", obj->stop);
fprintf(f, " version=\"%s\"", obj->version);
if (obj->label != NULL)
    fprintf(f, " label=\"%s\"", obj->label);
fprintf(f, ">");
fprintf(f, "\n");
for (dgFeature = obj->dgFeature; dgFeature != NULL; dgFeature = dgFeature->next)
   dgFeatureSave(dgFeature, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</SEGMENT>\n");
}

struct dgSegment *dgSegmentLoad(char *fileName)
/* Load dgSegment from file. */
{
struct dgSegment *obj;
xapParseAny(fileName, "SEGMENT", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgFeatureSave(struct dgFeature *obj, int indent, FILE *f)
/* Save dgFeature to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<FEATURE");
fprintf(f, " id=\"%s\"", obj->id);
if (obj->label != NULL)
    fprintf(f, " label=\"%s\"", obj->label);
if (obj->version != NULL)
    fprintf(f, " version=\"%s\"", obj->version);
fprintf(f, ">");
fprintf(f, "\n");
dgTypeSave(obj->dgType, indent+2, f);
dgMethodSave(obj->dgMethod, indent+2, f);
dgStartSave(obj->dgStart, indent+2, f);
dgEndSave(obj->dgEnd, indent+2, f);
dgScoreSave(obj->dgScore, indent+2, f);
dgOrientationSave(obj->dgOrientation, indent+2, f);
dgPhaseSave(obj->dgPhase, indent+2, f);
dgGroupSave(obj->dgGroup, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</FEATURE>\n");
}

struct dgFeature *dgFeatureLoad(char *fileName)
/* Load dgFeature from file. */
{
struct dgFeature *obj;
xapParseAny(fileName, "FEATURE", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgTypeSave(struct dgType *obj, int indent, FILE *f)
/* Save dgType to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TYPE");
if (obj->id != NULL)
    fprintf(f, " id=\"%s\"", obj->id);
if (obj->category != NULL)
    fprintf(f, " category=\"%s\"", obj->category);
if (obj->reference != NULL)
    fprintf(f, " reference=\"%s\"", obj->reference);
if (obj->subparts != NULL)
    fprintf(f, " subparts=\"%s\"", obj->subparts);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</TYPE>\n");
}

struct dgType *dgTypeLoad(char *fileName)
/* Load dgType from file. */
{
struct dgType *obj;
xapParseAny(fileName, "TYPE", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgMethodSave(struct dgMethod *obj, int indent, FILE *f)
/* Save dgMethod to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<METHOD");
if (obj->id != NULL)
    fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</METHOD>\n");
}

struct dgMethod *dgMethodLoad(char *fileName)
/* Load dgMethod from file. */
{
struct dgMethod *obj;
xapParseAny(fileName, "METHOD", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgStartSave(struct dgStart *obj, int indent, FILE *f)
/* Save dgStart to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<START>");
fprintf(f, "%s", obj->text);
fprintf(f, "</START>\n");
}

struct dgStart *dgStartLoad(char *fileName)
/* Load dgStart from file. */
{
struct dgStart *obj;
xapParseAny(fileName, "START", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgEndSave(struct dgEnd *obj, int indent, FILE *f)
/* Save dgEnd to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<END>");
fprintf(f, "%s", obj->text);
fprintf(f, "</END>\n");
}

struct dgEnd *dgEndLoad(char *fileName)
/* Load dgEnd from file. */
{
struct dgEnd *obj;
xapParseAny(fileName, "END", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgScoreSave(struct dgScore *obj, int indent, FILE *f)
/* Save dgScore to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<SCORE>");
fprintf(f, "%s", obj->text);
fprintf(f, "</SCORE>\n");
}

struct dgScore *dgScoreLoad(char *fileName)
/* Load dgScore from file. */
{
struct dgScore *obj;
xapParseAny(fileName, "SCORE", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgOrientationSave(struct dgOrientation *obj, int indent, FILE *f)
/* Save dgOrientation to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<ORIENTATION>");
fprintf(f, "%s", obj->text);
fprintf(f, "</ORIENTATION>\n");
}

struct dgOrientation *dgOrientationLoad(char *fileName)
/* Load dgOrientation from file. */
{
struct dgOrientation *obj;
xapParseAny(fileName, "ORIENTATION", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgPhaseSave(struct dgPhase *obj, int indent, FILE *f)
/* Save dgPhase to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<PHASE>");
fprintf(f, "%s", obj->text);
fprintf(f, "</PHASE>\n");
}

struct dgPhase *dgPhaseLoad(char *fileName)
/* Load dgPhase from file. */
{
struct dgPhase *obj;
xapParseAny(fileName, "PHASE", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgGroupSave(struct dgGroup *obj, int indent, FILE *f)
/* Save dgGroup to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<GROUP");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, ">");
fprintf(f, "\n");
dgNoteSave(obj->dgNote, indent+2, f);
dgLinkSave(obj->dgLink, indent+2, f);
dgTargetSave(obj->dgTarget, indent+2, f);
xapIndent(indent, f);
fprintf(f, "</GROUP>\n");
}

struct dgGroup *dgGroupLoad(char *fileName)
/* Load dgGroup from file. */
{
struct dgGroup *obj;
xapParseAny(fileName, "GROUP", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgNoteSave(struct dgNote *obj, int indent, FILE *f)
/* Save dgNote to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<NOTE>");
fprintf(f, "%s", obj->text);
fprintf(f, "</NOTE>\n");
}

struct dgNote *dgNoteLoad(char *fileName)
/* Load dgNote from file. */
{
struct dgNote *obj;
xapParseAny(fileName, "NOTE", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgLinkSave(struct dgLink *obj, int indent, FILE *f)
/* Save dgLink to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<LINK");
fprintf(f, " href=\"%s\"", obj->href);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</LINK>\n");
}

struct dgLink *dgLinkLoad(char *fileName)
/* Load dgLink from file. */
{
struct dgLink *obj;
xapParseAny(fileName, "LINK", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void dgTargetSave(struct dgTarget *obj, int indent, FILE *f)
/* Save dgTarget to file. */
{
if (obj == NULL) return;
xapIndent(indent, f);
fprintf(f, "<TARGET");
fprintf(f, " id=\"%s\"", obj->id);
fprintf(f, " start=\"%s\"", obj->start);
fprintf(f, " stop=\"%s\"", obj->stop);
fprintf(f, ">");
fprintf(f, "%s", obj->text);
fprintf(f, "</TARGET>\n");
}

struct dgTarget *dgTargetLoad(char *fileName)
/* Load dgTarget from file. */
{
struct dgTarget *obj;
xapParseAny(fileName, "TARGET", dgStartHandler, dgEndHandler, NULL, &obj);
return obj;
}

void *dgStartHandler(struct xap *xp, char *name, char **atts)
/* Called by expat with start tag.  Does most of the parsing work. */
{
struct xapStack *st = xp->stack+1;
int depth = xp->stackDepth;
int i;

if (sameString(name, "DASGFF"))
    {
    struct dgDasgff *obj;
    AllocVar(obj);
    return obj;
    }
else if (sameString(name, "GFF"))
    {
    struct dgGff *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "version"))
            obj->version = cloneString(val);
        else if (sameString(name, "href"))
            obj->href = cloneString(val);
        }
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (obj->href == NULL)
        xapError(xp, "missing href");
    if (depth > 1)
        {
        if  (sameString(st->elName, "DASGFF"))
            {
            struct dgDasgff *parent = st->object;
            slAddHead(&parent->dgGff, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "SEGMENT"))
    {
    struct dgSegment *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "start"))
            obj->start = atoi(val);
        else if (sameString(name, "stop"))
            obj->stop = atoi(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        else if (sameString(name, "label"))
            obj->label = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (obj->version == NULL)
        xapError(xp, "missing version");
    if (depth > 1)
        {
        if  (sameString(st->elName, "GFF"))
            {
            struct dgGff *parent = st->object;
            slAddHead(&parent->dgSegment, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "FEATURE"))
    {
    struct dgFeature *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "label"))
            obj->label = cloneString(val);
        else if (sameString(name, "version"))
            obj->version = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "SEGMENT"))
            {
            struct dgSegment *parent = st->object;
            slAddHead(&parent->dgFeature, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "TYPE"))
    {
    struct dgType *obj;
    AllocVar(obj);
    obj->reference = "no";
    obj->subparts = "no";
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "category"))
            obj->category = cloneString(val);
        else if (sameString(name, "reference"))
            obj->reference = cloneString(val);
        else if (sameString(name, "subparts"))
            obj->subparts = cloneString(val);
        }
    if (depth > 1)
        {
        if  (sameString(st->elName, "FEATURE"))
            {
            struct dgFeature *parent = st->object;
            slAddHead(&parent->dgType, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "METHOD"))
    {
    struct dgMethod *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        }
    if (depth > 1)
        {
        if  (sameString(st->elName, "FEATURE"))
            {
            struct dgFeature *parent = st->object;
            slAddHead(&parent->dgMethod, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "START"))
    {
    struct dgStart *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "FEATURE"))
            {
            struct dgFeature *parent = st->object;
            slAddHead(&parent->dgStart, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "END"))
    {
    struct dgEnd *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "FEATURE"))
            {
            struct dgFeature *parent = st->object;
            slAddHead(&parent->dgEnd, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "SCORE"))
    {
    struct dgScore *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "FEATURE"))
            {
            struct dgFeature *parent = st->object;
            slAddHead(&parent->dgScore, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "ORIENTATION"))
    {
    struct dgOrientation *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "FEATURE"))
            {
            struct dgFeature *parent = st->object;
            slAddHead(&parent->dgOrientation, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "PHASE"))
    {
    struct dgPhase *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "FEATURE"))
            {
            struct dgFeature *parent = st->object;
            slAddHead(&parent->dgPhase, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "GROUP"))
    {
    struct dgGroup *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (depth > 1)
        {
        if  (sameString(st->elName, "FEATURE"))
            {
            struct dgFeature *parent = st->object;
            slAddHead(&parent->dgGroup, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "NOTE"))
    {
    struct dgNote *obj;
    AllocVar(obj);
    if (depth > 1)
        {
        if  (sameString(st->elName, "GROUP"))
            {
            struct dgGroup *parent = st->object;
            slAddHead(&parent->dgNote, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "LINK"))
    {
    struct dgLink *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "href"))
            obj->href = cloneString(val);
        }
    if (obj->href == NULL)
        xapError(xp, "missing href");
    if (depth > 1)
        {
        if  (sameString(st->elName, "GROUP"))
            {
            struct dgGroup *parent = st->object;
            slAddHead(&parent->dgLink, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else if (sameString(name, "TARGET"))
    {
    struct dgTarget *obj;
    AllocVar(obj);
    for (i=0; atts[i] != NULL; i += 2)
        {
        char *name = atts[i], *val = atts[i+1];
        if  (sameString(name, "id"))
            obj->id = cloneString(val);
        else if (sameString(name, "start"))
            obj->start = cloneString(val);
        else if (sameString(name, "stop"))
            obj->stop = cloneString(val);
        }
    if (obj->id == NULL)
        xapError(xp, "missing id");
    if (obj->start == NULL)
        xapError(xp, "missing start");
    if (obj->stop == NULL)
        xapError(xp, "missing stop");
    if (depth > 1)
        {
        if  (sameString(st->elName, "GROUP"))
            {
            struct dgGroup *parent = st->object;
            slAddHead(&parent->dgTarget, obj);
            }
        else
            xapError(xp, "%s misplaced", name);
        }
    return obj;
    }
else
    {
    xapSkip(xp);
    return NULL;
    }
}

void dgEndHandler(struct xap *xp, char *name)
/* Called by expat with end tag.  Checks all required children are loaded. */
{
struct xapStack *stack = xp->stack;
if (sameString(name, "DASGFF"))
    {
    struct dgDasgff *obj = stack->object;
    if (obj->dgGff == NULL)
        xapError(xp, "Missing GFF");
    if (obj->dgGff->next != NULL)
        xapError(xp, "Multiple GFF");
    }
else if (sameString(name, "GFF"))
    {
    struct dgGff *obj = stack->object;
    if (obj->dgSegment == NULL)
        xapError(xp, "Missing SEGMENT");
    }
else if (sameString(name, "SEGMENT"))
    {
    struct dgSegment *obj = stack->object;
    if (obj->dgFeature == NULL)
        xapError(xp, "Missing FEATURE");
    }
else if (sameString(name, "FEATURE"))
    {
    struct dgFeature *obj = stack->object;
    if (obj->dgType == NULL)
        xapError(xp, "Missing TYPE");
    if (obj->dgType->next != NULL)
        xapError(xp, "Multiple TYPE");
    if (obj->dgMethod == NULL)
        xapError(xp, "Missing METHOD");
    if (obj->dgMethod->next != NULL)
        xapError(xp, "Multiple METHOD");
    if (obj->dgStart == NULL)
        xapError(xp, "Missing START");
    if (obj->dgStart->next != NULL)
        xapError(xp, "Multiple START");
    if (obj->dgEnd == NULL)
        xapError(xp, "Missing END");
    if (obj->dgEnd->next != NULL)
        xapError(xp, "Multiple END");
    if (obj->dgScore == NULL)
        xapError(xp, "Missing SCORE");
    if (obj->dgScore->next != NULL)
        xapError(xp, "Multiple SCORE");
    if (obj->dgOrientation == NULL)
        xapError(xp, "Missing ORIENTATION");
    if (obj->dgOrientation->next != NULL)
        xapError(xp, "Multiple ORIENTATION");
    if (obj->dgPhase == NULL)
        xapError(xp, "Missing PHASE");
    if (obj->dgPhase->next != NULL)
        xapError(xp, "Multiple PHASE");
    if (obj->dgGroup != NULL && obj->dgGroup->next != NULL)
        xapError(xp, "Multiple GROUP");
    }
else if (sameString(name, "TYPE"))
    {
    struct dgType *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "METHOD"))
    {
    struct dgMethod *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "START"))
    {
    struct dgStart *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "END"))
    {
    struct dgEnd *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "SCORE"))
    {
    struct dgScore *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "ORIENTATION"))
    {
    struct dgOrientation *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "PHASE"))
    {
    struct dgPhase *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "GROUP"))
    {
    struct dgGroup *obj = stack->object;
    if (obj->dgNote != NULL && obj->dgNote->next != NULL)
        xapError(xp, "Multiple NOTE");
    if (obj->dgLink != NULL && obj->dgLink->next != NULL)
        xapError(xp, "Multiple LINK");
    if (obj->dgTarget != NULL && obj->dgTarget->next != NULL)
        xapError(xp, "Multiple TARGET");
    }
else if (sameString(name, "NOTE"))
    {
    struct dgNote *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "LINK"))
    {
    struct dgLink *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
else if (sameString(name, "TARGET"))
    {
    struct dgTarget *obj = stack->object;
    obj->text = cloneString(stack->text->string);
    }
}

